const colorMap = {
  // standart
  0: 30, // black
  1: 31, // red
  2: 32, // green
  3: 33, // yellow
  4: 34, // blue
  5: 35, // magenta
  6: 36, // cyan
  7: 37, // white
  // bright
  8: 90, // black
  9: 91, // red
  10: 92, // green
  11: 93, // yellow
  12: 94, // blue
  13: 95, // magenta
  14: 96, // cyan
  15: 97 // white
};

const hexToAnsi = (hex) => {
  hex = hex.replace(/^#/, '');
  if (hex.length === 3) hex = hex.split('').map(c => c + c).join('');
  const r = parseInt(hex.slice(0, 2), 16);
  const g = parseInt(hex.slice(2, 4), 16);
  const b = parseInt(hex.slice(4, 6), 16);
  return `\x1b[38;2;${r};${g};${b}m`;
};

const printc = (COL, TX) => {
  let colorCode;
  if (colorMap[COL] !== undefined) {
    colorCode = colorMap[COL];
  } else if (/^#?[0-9A-Fa-f]{6}$/.test(COL)) {
    return hexToAnsi(COL) + TX + '\x1b[0m';
  } else if (COL == -1) {
    return TX;
  } else {
    throw new Error('Invalid color format');
  }
  return `\x1b[${colorCode}m${TX}\x1b[0m`;
};

export default printc;